
// SingleInstanceDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SingleInstance.h"
#include "SingleInstanceDlg.h"
#include "afxdialogex.h"

#include <Sddl.h>          // for SID management
#include <tchar.h>
#include <strsafe.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CSingleInstanceDlg dialog




CSingleInstanceDlg::CSingleInstanceDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CSingleInstanceDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSingleInstanceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_REPORTSTATE, m_strReport);
}

BEGIN_MESSAGE_MAP(CSingleInstanceDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CSingleInstanceDlg message handlers

BOOL CSingleInstanceDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_strReport = _T("");
	m_hSingle = NULL;
	m_hBoundary = NULL;
	m_hNamespace = NULL;
	m_bNamespaceOpened = FALSE;
	CheckInstances();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSingleInstanceDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSingleInstanceDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSingleInstanceDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSingleInstanceDlg::CheckInstances() 
{
	CString m_strMessage;
   // ایجاد یک توصیفگر مرزی
	PCTSTR strNamespace = TEXT("KingNamespace");
   m_hBoundary = CreateBoundaryDescriptor(TEXT("KingBoundry"), 0);

   // ایجاد یک شناسه امنیت متناظر با گروه مدیران محلی سیستم
   BYTE localAdminSID[SECURITY_MAX_SID_SIZE];
   PSID pLocalAdminSID = &localAdminSID;
   DWORD cbSID = sizeof(localAdminSID);
   if (!CreateWellKnownSid(WinBuiltinAdministratorsSid, 
		NULL, pLocalAdminSID, &cbSID)) 
	{
		m_strMessage.Format(TEXT("AddSIDToBoundaryDescriptor failed: %u\r\n"), GetLastError());
		AddText(m_strMessage);
      return;
   }
   
   // مرتبط کردن شناسه امنیتی مدیران محلی سیستم به توصیف گر مرزی
	// فقط برنامه های در حال اجرا تحت کاربر مدیر سیستم
	// قادر خواهند بود که به اشیاء هسته در این نامکده دسترسی داشته باشند
   if (!AddSIDToBoundaryDescriptor(&m_hBoundary, pLocalAdminSID)) 
	{
      m_strMessage.Format(TEXT("AddSIDToBoundaryDescriptor failed: %u\r\n"), GetLastError());
		AddText(m_strMessage);
      return;
   }

	// تبدیل شناسه امنیتی مدیران محلی سیستم به ساختمان ویژگی های امنیتی
   SECURITY_ATTRIBUTES sa;
   sa.nLength = sizeof(sa);
   sa.bInheritHandle = FALSE;
   if (!ConvertStringSecurityDescriptorToSecurityDescriptor(
      TEXT("D:(A;;GA;;;BA)"), 
      SDDL_REVISION_1, &sa.lpSecurityDescriptor, NULL)) 
	{
      m_strMessage.Format(TEXT("Security Descriptor creation failed: %u\r\n"), GetLastError());
		AddText(m_strMessage);
      return;
   }
	// ایجاد یک نامکدۀ خصوصی که فقط  مدیران محلی سیستم به آن دسترسی دارند
   m_hNamespace = CreatePrivateNamespace(&sa, m_hBoundary, strNamespace);

   // رهاسازی حافظۀ تخصیص یافته به شئ توصیف گر امنیت
   LocalFree(sa.lpSecurityDescriptor);

	// بررسی نتیجه ایجاد نامکده خصوصی
   DWORD dwLastError = GetLastError();
   if (m_hNamespace == NULL) 
	{
		// چیزی برای انجام وجود ندارد اگر دسترسی رد شود
      // این کد فقط باید تحت حساب مدیران محلی اجرا شود
      if (dwLastError == ERROR_ACCESS_DENIED) 
		{
         AddText( TEXT("Access denied when creating the namespace.\r\n") );
         AddText( TEXT("   You must be running as Administrator.\r\n\r\n") );

         return;
      } 
		else 
		{ 
         if (dwLastError == ERROR_ALREADY_EXISTS) 
			{
				// اگر نمونه دیگر قبلاً نامکده را ایجاد کرده است
            // باید آن را باز کنیم
				m_strMessage.Format(TEXT("CreatePrivateNamespace failed: %u\r\n"), dwLastError);
            AddText(m_strMessage);
            m_hNamespace = OpenPrivateNamespace(m_hBoundary, strNamespace);
				
            if (m_hNamespace == NULL) 
				{
               m_strMessage.Format(TEXT("   and OpenPrivateNamespace failed: %u\r\n"), dwLastError);
					AddText(m_strMessage);
               return;
            } 
				else 
				{
               m_bNamespaceOpened = TRUE;
               AddText( TEXT("   but OpenPrivateNamespace succeeded\r\n\r\n"));
					
            }
         } 
			else 
			{
            m_strMessage.Format(TEXT("Unexpected error occured: %u\r\n\r\n"), dwLastError);
				AddText(m_strMessage);
            return;
         }
      }
   }
   
	// تلاش برای ایجاد شیء موتکسی با نامی مبتنی بر نامکدۀ خصوصی
   TCHAR szMutexName[64];
   StringCchPrintf(szMutexName, _countof(szMutexName), TEXT("%s\\%s"), 
      strNamespace, TEXT("SingleInsrance"));

   m_hSingle = CreateMutex(NULL, FALSE, szMutexName);
   if (GetLastError() == ERROR_ALREADY_EXISTS) // نمونه ای از این شئ منحصربفرد از قبل موجود است
	{ 
      AddText( TEXT("Another instance of Singleton is running:\r\n") );
      AddText( TEXT("--> Impossible to access application features.\r\n") );
   } 
	else  // اولین باری است که این شئ منحصربفرد ایجاد می شود
	{
      AddText( TEXT("First instance of Singleton:\r\n") );
      AddText( TEXT("--> Access application features now.\r\n") );
   }
	UpdateData(FALSE);
}

void CSingleInstanceDlg::AddText(CString strMessage)
{
	m_strReport += strMessage;
	UpdateData(FALSE);

}
void CSingleInstanceDlg::OnClose()
{
	
	if (m_hSingle != NULL) 
	{
      CloseHandle(m_hSingle);
   }

   if (m_hNamespace != NULL) 
	{
      if (m_bNamespaceOpened) 
		{  // نامکده باز شده است
         ClosePrivateNamespace(m_hNamespace, 0);
      } 
		else 
		{ // نامکده ایجاد شده است
         ClosePrivateNamespace(m_hNamespace, PRIVATE_NAMESPACE_FLAG_DESTROY);
      }
   }

   if (m_hBoundary != NULL) 
	{
      DeleteBoundaryDescriptor(m_hBoundary);
   }

	CDialogEx::OnClose();
}
